#!/usr/local/bin/perl
##!/usr/local/bin/perl
#
#	MT検索CGI
#	2008.08.02新規作成
#	・SQLiteのみ対応
#
#	2008.09.17
#	mt-search.cgiの変わりに使える様にしてみる。
#
#	2009.08.11
#	・SQLのバグを修正。
#	・mysqlでも動くようにした。
#
#	2009.08.11.02
#	・DBの設定をmt-config.cgiから自動で読み取る様に変更
#	・セキュリティ考慮してSELECT時にプレペアドステートメントの使用
#
#	2009.09.09.01
#	・MySQL時でMTを新規インストールした環境で検索できない場合があるので調査。set names utf8が必要なので追加。
#
#	2009.09.09.02
#	・;mysql_server_prepare=1を追加
#
#
use strict;
#use warnings;
use DBI;
use Encode::Guess qw/ascii utf8 euc-jp shiftjis 7bit-jis/;

#バージョン(変更の必要なし)
#my $ver			= 'v.2009.08.11.04';
my $ver			= 'v.2009.09.09.02';

#CGI名(変更の必要なし)
my $cginame		=  './kumasearch.cgi';

#著作権表示(変更の必要なし)
my $footer=<<"EOF";
KUMA SEARCH $ver
Copyright (C) 2008-2009 <a href="http://blog.kumacchi.com/">KUMA TYPE.</a> All Rights Reserved.
EOF

#---------------------設定ここから-------------------------------------------------
#ブログのURL
my $CFG_BLOG_URL	= '/';

#mt-config path
my $CFG_MT_CONFIG_PATH	= '../mt-config.cgi';

#最大何件まで検索するかを指定
my $CFG_MAX_SEARCH_RECODE	= 20;

#一覧に表示する記事本文中、何文字まで表示するか
my $CFG_MAX_LENGTH	= 128;

#リンククリック時のターゲット指定
my $CFG_LINK_TARGET	= 'target="_blank"';

my $CFG_ORDER_BY	= 'DESC';

#メニュー部分(適当にHTMLタグで)
my $CFG_MENU=<<"EOF";
<a href="$CFG_BLOG_URL">| ブログに戻る |</a>
EOF
#---------------------設定ここまで-------------------------------------------------

my %in = ();
my %cfg = ();
&idecode();
&loadConfig();

#unless($in{'IncludeBlogs'}){
#	$in{'IncludeBlogs'} = 1;
#}

#入力チェック
if(length($in{'tag'}) > 1000){
	&error('検索タグが長すぎます');
}

if($in{'tag'} and (length(Encode::decode('utf8', $in{'tag'}))>256)){
	&error('検索タグが長すぎます');
}

if(length($in{'search'}) > 1000){
	&error('検索キーワードが長すぎます');
}

if($in{'search'} and (length(Encode::decode('utf8', $in{'search'}))>256)){
	&error('検索キーワードが長すぎます');
}

if($in{'limit'} =~ /[^0-9]/){
	&error('limitに数字以外の値が含まれています。');
}

if(length($in{'limit'}) > 3){
	&error('limitの桁が大きすぎます。');
}

if($in{'blog_id'} && ($in{'IncludeBlogs'} eq '')){
	$in{'IncludeBlogs'} = $in{'blog_id'};
}

if($in{'IncludeBlogs'} =~ /[^0-9]/){
	&error('IncludeBlogsに数字以外の値が含まれています。');
}

if(length($in{'IncludeBlogs'}) > 2){
	&error('IncludeBlogsの桁が大きすぎます。');
}

if($in{'search'}){
	my $dec = Encode::Guess->guess($in{'search'});
	if(ref $dec){
		$in{'search'} = $dec->decode($in{'search'});
		utf8::encode($in{'search'});
	}
}

if($in{'tag'}){
	my $dec = Encode::Guess->guess($in{'tag'});
	if(ref $dec){
		$in{'tag'} = $dec->decode($in{'tag'});
		utf8::encode($in{'tag'});
	}
}

&top();
exit(0);

#----------------------------------------------------------
#	トップページ
#----------------------------------------------------------
sub top{
	print "Content-type: text/html\n\n";

#<!--meta name="robots" content="NOINDEX,NOFOLLOW,NOARCHIVE"-->
	print <<"EOF";
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html lang="ja">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>記事検索</title>
<link rel="stylesheet" href="./kumasearch.css" type="text/css">
</head>
<body>
<div id="main">
	<div id="menu">
		$CFG_MENU
	</div>
	<div id="title">
		記事検索
	</div>
	<div id="message">
		キーワードを入力してブログエントリを検索出来ます。<br />スペースで区切ってキーワード複数入力する事でAND検索出来ます。
	</div>
	<div id="search">
		<form name="search" method="post" action="$cginame">
			キーワード：<input type="text" name="search" maxlength="100" size="60" value="$in{'search'}"><input type="submit" name="submit" value="検索実行" id="btn">
		</form>
	</div>
	<div id="search_result">
EOF

#	if($in{'MODE'} eq 'search' and $in{'search'}){
	if($in{'search'}){
		&search_result();
	}elsif($in{'tag'}){
		&tag_search_result();
	}else{
		print '<div id="result_count">ここに検索結果が表示されます。</div>';
	}


print <<"EOF";
	</div>
	<div id="footer">
		$footer
	</div>
</div>
</body>
</html>
EOF

}

#----------------------------------------------------------
#	エラー処理
#----------------------------------------------------------
sub error{
	print "Content-type: text/html\n\n";
	print << "EOF";
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html lang="ja">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<!--meta name="robots" content="NOINDEX,NOFOLLOW,NOARCHIVE"-->
<TITLE>エラー</TITLE>
</HEAD>
<BODY>
<CENTER><BR>
<HR size="1">
error:$_[0]<BR>
<HR size="1"><BR>
<A href="javascript:history.back()">戻る</A></CENTER>
</BODY>
</HTML>
EOF
exit(-1);
}

#----------------------------------------------------------
# 引数取得
#----------------------------------------------------------
sub idecode{
	my $QUERY_DATA='';
	if($ENV{'REQUEST_METHOD'} eq "POST"){
		read(STDIN,$QUERY_DATA,$ENV{'CONTENT_LENGTH'});
	}else{
		$QUERY_DATA = $ENV{'QUERY_STRING'};
	}

	my @argv = split(/&/,$QUERY_DATA);
	# 引数の取得処理
	foreach(@argv){
		my ($arg,$val) = split(/=/);
		$val =~ tr/+/ /;
		$val =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("H2",$1)/eg;
		$val =~ s/,/，/g;
		$val =~ s/</&lt;/g;
		$val =~ s/>/&gt;/g;
		$val =~ s/"/&quot;/g;
		$val =~ s/'/&apos;/g;
		$val =~ s/&/&amp;/g;

		$val =~ s/(?:\x0d|0x0a)//g;
		$val =~ s/\t//g;

		$in{"$arg"} = $val;
	}
}

#----------------------------------------------------------
#	検索
#----------------------------------------------------------
sub search_result{

	my @keys = split(/　| /,$in{'search'});
	my @keys2 = ();
	my $SEARCH_SQL_UNIT = '';
	foreach my $key (@keys){
#		$SEARCH_SQL_UNIT = ($SEARCH_SQL_UNIT eq '') ? "entry_text||entry_text_more||entry_title LIKE '%$key%'" : " AND entry_text||entry_text_more||entry_title LIKE '%$key%'";
#		$SEARCH_SQL_UNIT .= ($SEARCH_SQL_UNIT eq '') ? "ifnull(E.entry_text,'')||ifnull(E.entry_text_more,'')||ifnull(E.entry_title,'') LIKE '%$key%'" : " AND ifnull(E.entry_text,'')||ifnull(E.entry_text_more,'')||ifnull(E.entry_title,'') LIKE '%$key%'";
		$SEARCH_SQL_UNIT .= ($SEARCH_SQL_UNIT eq '') ? "ifnull(E.entry_text,'')||ifnull(E.entry_text_more,'')||ifnull(E.entry_title,'') LIKE ?" : " AND ifnull(E.entry_text,'')||ifnull(E.entry_text_more,'')||ifnull(E.entry_title,'') LIKE ?";
		push(@keys2,"%$key%");
	}

	if($SEARCH_SQL_UNIT){
		$SEARCH_SQL_UNIT = "($SEARCH_SQL_UNIT)";
	}

	my $cnt =0;
	my $hDB;

	#my $hDB = DBI->connect("dbi:SQLite:dbname=$CFG_DBPATH","","",{PrintError=>0});
	#my $hDB = DBI->connect("DBI:mysql:dbname:server","id","password",{PrintError=>0});
	if($cfg{'ObjectDriver'} =~ /sqlite/i){
		$hDB = DBI->connect("DBI:SQLite:dbname=$cfg{Database}","","",{PrintError=>0});
	}else{
		$cfg{'ObjectDriver'} =~ s/\:\:/\:/;
		$hDB = DBI->connect("$cfg{ObjectDriver}:$cfg{Database}:$cfg{DBHost};mysql_server_prepare=1","$cfg{DBUser}","$cfg{DBPassword}",{PrintError=>0});
	}
	unless($hDB){&error($DBI::errstr);}
	$hDB->do("set names utf8");

	#検索
#	my $SQL = "SELECT entry_id,entry_text,entry_text_more,entry_title,entry_created_on FROM mt_entry WHERE $SEARCH_SQL_UNIT ORDER BY entry_id LIMIT 20";
	my $SQL;
	if($in{'IncludeBlogs'} && $in{'limit'}){
		$SQL = "SELECT E.entry_id,E.entry_text,E.entry_text_more,E.entry_title,E.entry_created_on,F.fileinfo_url FROM mt_entry AS E,mt_fileinfo AS F WHERE E.entry_status = 2 AND E.entry_blog_id = ? AND F.fileinfo_entry_id = E.entry_id AND $SEARCH_SQL_UNIT ORDER BY E.entry_id $CFG_ORDER_BY LIMIT ?";
	}elsif($in{'IncludeBlogs'}){
		$SQL = "SELECT E.entry_id,E.entry_text,E.entry_text_more,E.entry_title,E.entry_created_on,F.fileinfo_url FROM mt_entry AS E,mt_fileinfo AS F WHERE E.entry_status = 2 AND E.entry_blog_id = ? AND F.fileinfo_entry_id = E.entry_id AND $SEARCH_SQL_UNIT ORDER BY E.entry_id $CFG_ORDER_BY LIMIT ?";
	}elsif($in{'limit'}){
		$SQL = "SELECT E.entry_id,E.entry_text,E.entry_text_more,E.entry_title,E.entry_created_on,F.fileinfo_url FROM mt_entry AS E,mt_fileinfo AS F WHERE E.entry_status = 2 AND F.fileinfo_entry_id = E.entry_id AND $SEARCH_SQL_UNIT ORDER BY E.entry_id $CFG_ORDER_BY LIMIT ?";
	}else{
		$SQL = "SELECT E.entry_id,E.entry_text,E.entry_text_more,E.entry_title,E.entry_created_on,F.fileinfo_url FROM mt_entry AS E,mt_fileinfo AS F WHERE E.entry_status = 2 AND F.fileinfo_entry_id = E.entry_id AND $SEARCH_SQL_UNIT ORDER BY E.entry_id $CFG_ORDER_BY LIMIT ?";
	}

#open(FILE,">sql.txt");
#print FILE "$SEARCH_SQL_UNIT\n";
#print FILE "$in{'IncludeBlogs'},$in{'limit'}\n";
#print FILE $SQL;
#close(FILE);


	my $hst = $hDB->prepare($SQL);

	if($hst){
		my $retval;
		if($in{'IncludeBlogs'} && $in{'limit'}){
#			$retval = $hst->execute($in{'IncludeBlogs'},"test",$in{'limit'});
#			$retval = $hst->execute($in{'IncludeBlogs'},$in{'limit'});
#			$retval = $hst->execute($in{'IncludeBlogs'},$in{'limit'});
			$retval = $hst->execute($in{'IncludeBlogs'},@keys2,$in{'limit'});
		}elsif($in{'IncludeBlogs'}){
			$retval = $hst->execute($in{'IncludeBlogs'},@keys2,$CFG_MAX_SEARCH_RECODE);
		}elsif($in{'limit'}){
			$retval = $hst->execute(@keys2,$in{'limit'});
		}else{
			$retval = $hst->execute(@keys2,$CFG_MAX_SEARCH_RECODE);
		}

		while(my ($entry_id,$entry_text,$entry_text_more,$entry_title,$entry_created_on,$fileinfo_url) = $hst->fetchrow_array){
#			$entry_text	 		=~ s/<(.*?)>/&lt;$1&gt;/ig;
#			$entry_text_more	=~ s/<(.*?)>/&lt;$1&gt;/ig;
#			$entry_title		=~ s/<(.*?)>/&lt;$1&gt;/ig;


#			utf8::encode($entry_text);
#			utf8::encode($entry_text_more);
#			utf8::encode($entry_title);

			$entry_text	 		=~ s/(<.*?>)//igs;
			$entry_text_more	=~ s/(<.*?>)//igs;
			$entry_title		=~ s/(<.*?>)//igs;

			utf8::decode($entry_text);
			my $entry_unit = substr($entry_text,0,$CFG_MAX_LENGTH);
			utf8::encode($entry_unit);
			if(length($entry_text) > $CFG_MAX_LENGTH){
				$entry_unit .= "…";
			}

#			foreach my $key (@keys){
#				$entry_unit	=~ s/($key)/<font color="red">$1<\/font>/ig;
#			}


#			foreach my $key (@keys){
#				$entry_text	 		=~ s/($key)/<font color="red">$1<\/font>/ig;
#				$entry_text_more	=~ s/($key)/<font color="red">$1<\/font>/ig;
#				$entry_title		=~ s/($key)/<font color="red">$1<\/font>/ig;
#			}

#			&printEntry($entry_title,$entry_created_on,$entry_text,$entry_text_more);
			&printEntry($entry_title,$entry_created_on,$entry_unit,'',$fileinfo_url);
			$cnt++;
		}
		$hst->finish;
	}else{
		# エラー処理
		&error($hDB->errstr);
	}

	#DB切断
	$hDB->disconnect;
	#HTMLを戻り値

print <<"EOF";
<div id="result_count">
	$cnt 件一致しました。(<font size="-1">$CFG_MAX_SEARCH_RECODE 件以上の場合は省略されます。キーワードで絞り込んでください。</font>)
</div>
EOF
}

#----------------------------------------------------------
#	タグ検索
#----------------------------------------------------------
sub tag_search_result{

	my $hDB;
	#my $hDB = DBI->connect("dbi:SQLite:dbname=$CFG_DBPATH","","",{PrintError=>0});
	#my $hDB = DBI->connect("DBI:mysql:dbname:server","id","password",{PrintError=>0});
	if($cfg{'ObjectDriver'} =~ /sqlite/i){
		$hDB = DBI->connect("DBI:SQLite:dbname=$cfg{Database}","","",{PrintError=>0});
	}else{
		$cfg{'ObjectDriver'} =~ s/\:\:/\:/;
		$hDB = DBI->connect("$cfg{ObjectDriver}:$cfg{Database}:$cfg{DBHost};mysql_server_prepare=1","$cfg{DBUser}","$cfg{DBPassword}",{PrintError=>0});
	}

	unless($hDB){&error($DBI::errstr);}
	$hDB->do("set names utf8");
	mysql_set_charset('utf8');

	#タグの検索
#	my $SQL = "SELECT tag_id,tag_n8d_id FROM mt_tag WHERE tag_name = '$in{tag}'";
	my $SQL = "SELECT tag_id,tag_n8d_id FROM mt_tag WHERE tag_name = ?";

#open(FILE,">dbg01.txt");
#print FILE $SQL;
#close(FILE);


	my $hst = $hDB->prepare($SQL);
	my @tag_id = ();
	if($hst){
		my $retval = $hst->execute($in{tag});
		while(my ($tag_id,$tag_n8d_id) = $hst->fetchrow_array){
			push(@tag_id,$tag_id);
			if($tag_n8d_id != 0){
				push(@tag_id,$tag_n8d_id);
			}
		}
		$hst->finish;
	}else{
		# エラー処理
		&error($hDB->errstr);
	}

	#一致するタグIDがなければ戻る
	return unless(scalar @tag_id);

	my $SEARCH_SQL_UNIT = '';
	foreach my $key (@tag_id){
		$SEARCH_SQL_UNIT .= ($SEARCH_SQL_UNIT eq '') ? "objecttag_tag_id = $key" : " OR objecttag_tag_id = $key";
	}

#open(FILE,">dbg02.txt");
#print FILE $SEARCH_SQL_UNIT;
#close(FILE);


	#タグIDに一致するエントリーIDをリストアップ
#	my $SQL2 = "SELECT objecttag_object_id FROM mt_objecttag WHERE objecttag_blog_id = $in{'IncludeBlogs'} AND ($SEARCH_SQL_UNIT) ORDER BY objecttag_object_id LIMIT $CFG_MAX_SEARCH_RECODE";
	my $SQL2;
	if($in{'IncludeBlogs'} && $in{'limit'}){
		$SQL2 = "SELECT objecttag_object_id FROM mt_objecttag WHERE objecttag_blog_id = ? AND ($SEARCH_SQL_UNIT) ORDER BY objecttag_object_id LIMIT ?";
	}elsif($in{'IncludeBlogs'}){
		$SQL2 = "SELECT objecttag_object_id FROM mt_objecttag WHERE objecttag_blog_id = ? AND ($SEARCH_SQL_UNIT) ORDER BY objecttag_object_id LIMIT ?";
	}elsif($in{'limit'}){
		$SQL2 = "SELECT objecttag_object_id FROM mt_objecttag WHERE ($SEARCH_SQL_UNIT) ORDER BY objecttag_object_id LIMIT ?";
	}else{
		$SQL2 = "SELECT objecttag_object_id FROM mt_objecttag WHERE ($SEARCH_SQL_UNIT) ORDER BY objecttag_object_id LIMIT ?";
	}

	my @entry_id = ();
	$hst = $hDB->prepare($SQL2);
	if($hst){
#		my $retval = $hst->execute;
		my $retval;
		if($in{'IncludeBlogs'} && $in{'limit'}){
			$retval = $hst->execute($in{'IncludeBlogs'},$in{'limit'});
		}elsif($in{'IncludeBlogs'}){
			$retval = $hst->execute($in{'IncludeBlogs'},$CFG_MAX_SEARCH_RECODE);
		}elsif($in{'limit'}){
			$retval = $hst->execute($CFG_MAX_SEARCH_RECODE);
		}else{
			$retval = $hst->execute($CFG_MAX_SEARCH_RECODE);
		}

		while(my ($objecttag_object_id) = $hst->fetchrow_array){
			push(@entry_id,$objecttag_object_id);
		}
		$hst->finish;
	}else{
		# エラー処理
		&error($hDB->errstr);
	}

	#一致するエントリーIDがなければ戻る
	return unless(scalar @entry_id);

	my $SEARCH_SQL_UNIT2 = '';
	foreach my $key (@entry_id){
		$SEARCH_SQL_UNIT2 .= ($SEARCH_SQL_UNIT2 eq '') ? "E.entry_id IN($key" : ",$key";
	}
	$SEARCH_SQL_UNIT2 .= ')';

	my $cnt =0;

	#検索
#	my $SQL3 = "SELECT E.entry_id,E.entry_text,E.entry_text_more,E.entry_title,E.entry_created_on,F.fileinfo_url FROM mt_entry AS E,mt_fileinfo AS F WHERE E.entry_blog_id = $in{'IncludeBlogs'} AND F.fileinfo_entry_id = E.entry_id AND $SEARCH_SQL_UNIT2 ORDER BY E.entry_id $CFG_ORDER_BY LIMIT $CFG_MAX_SEARCH_RECODE";
	my $SQL3;
	if($in{'IncludeBlogs'} && $in{'limit'}){
		$SQL3 = "SELECT E.entry_id,E.entry_text,E.entry_text_more,E.entry_title,E.entry_created_on,F.fileinfo_url FROM mt_entry AS E,mt_fileinfo AS F WHERE E.entry_blog_id = ? AND F.fileinfo_entry_id = E.entry_id AND $SEARCH_SQL_UNIT2 ORDER BY E.entry_id $CFG_ORDER_BY LIMIT ?";
	}elsif($in{'IncludeBlogs'}){
		$SQL3 = "SELECT E.entry_id,E.entry_text,E.entry_text_more,E.entry_title,E.entry_created_on,F.fileinfo_url FROM mt_entry AS E,mt_fileinfo AS F WHERE E.entry_blog_id = ? AND F.fileinfo_entry_id = E.entry_id AND $SEARCH_SQL_UNIT2 ORDER BY E.entry_id $CFG_ORDER_BY LIMIT ?";
	}elsif($in{'limit'}){
		$SQL3 = "SELECT E.entry_id,E.entry_text,E.entry_text_more,E.entry_title,E.entry_created_on,F.fileinfo_url FROM mt_entry AS E,mt_fileinfo AS F WHERE F.fileinfo_entry_id = E.entry_id AND $SEARCH_SQL_UNIT2 ORDER BY E.entry_id $CFG_ORDER_BY LIMIT ?";
	}else{
		$SQL3 = "SELECT E.entry_id,E.entry_text,E.entry_text_more,E.entry_title,E.entry_created_on,F.fileinfo_url FROM mt_entry AS E,mt_fileinfo AS F WHERE F.fileinfo_entry_id = E.entry_id AND $SEARCH_SQL_UNIT2 ORDER BY E.entry_id $CFG_ORDER_BY LIMIT ?";
	}


	$hst = $hDB->prepare($SQL3);

	if($hst){
#		my $retval = $hst->execute;
		my $retval;
		if($in{'IncludeBlogs'} && $in{'limit'}){
			$retval = $hst->execute($in{'IncludeBlogs'},$in{'limit'});
		}elsif($in{'IncludeBlogs'}){
			$retval = $hst->execute($in{'IncludeBlogs'},$CFG_MAX_SEARCH_RECODE);
		}elsif($in{'limit'}){
			$retval = $hst->execute($CFG_MAX_SEARCH_RECODE);
		}else{
			$retval = $hst->execute($CFG_MAX_SEARCH_RECODE);
		}

		while(my ($entry_id,$entry_text,$entry_text_more,$entry_title,$entry_created_on,$fileinfo_url) = $hst->fetchrow_array){
			$entry_text	 		=~ s/(<.*?>)//igs;
			$entry_text_more	=~ s/(<.*?>)//igs;
			$entry_title		=~ s/(<.*?>)//igs;

			utf8::decode($entry_text);
			my $entry_unit = substr($entry_text,0,$CFG_MAX_LENGTH);
			utf8::encode($entry_unit);
			if(length($entry_text) > $CFG_MAX_LENGTH){
				$entry_unit .= "…";
			}
			&printEntry($entry_title,$entry_created_on,$entry_unit,'',$fileinfo_url);
			$cnt++;
		}
		$hst->finish;
	}else{
		# エラー処理
		&error($hDB->errstr);
	}

	$hst=undef;

	#DB切断
	$hDB->disconnect;
	#HTMLを戻り値

print <<"EOF";
<div id="result_count">
	$cnt 件一致しました。(<font size="-1">$CFG_MAX_SEARCH_RECODE 件以上の場合は省略されます。キーワードで絞り込んでください。</font>)
</div>
EOF
}

#----------------------------------------------------------
#	エントリー出力
#----------------------------------------------------------
sub printEntry{
print <<"EOF";
<div class="entry">
	<div class="entry_title">
		<a href="$_[4]" $CFG_LINK_TARGET>$_[0]</a>
	</div>
	<div class="entry_date">
		投稿日：$_[1]
	</div>
	<div class="entry_text">
		$_[2]$_[3]
	</div>
</div>
EOF
}

#----------------------------------------------------------
#	
#----------------------------------------------------------
sub loadConfig{
	open(FILE,$CFG_MT_CONFIG_PATH) || &error("file open error");
	while(<FILE>){
		my($arg,$val) = split(/\s+/);
		next if($arg eq '');
		next if($arg =~ /^#/);
		$cfg{"$arg"} = $val;
	}
	close(FILE);
}
